#include <iostream>
#include<vector>
#include<cmath>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int N,Q,L,R;
    cin>>N>>Q;
    vector<int> A(N);
    for(int i=0;i<N;i++){
        int rw;
        cin>>rw;
        A[i]=(int)log2(rw);
    }
    /*
    for(int i=0;i<N;i++){
        cout<<A[i]<<" ";
    }
    */
    vector<int> ans(Q);
    for(int i=0;i<Q;i++){
        cin>>L>>R;
        vector<int> frek(31);
        for(int j=L-1;j<R;j++){
            frek[A[j]]++;
        }
        /*
        cout<<"\n";
        for(int ind=0;ind<frek.size();ind++){
            cout<<frek[ind]<<" ";
        }
        cout<<"\n";
        */
        int mind=frek[0];
        for(int ind=1;ind<frek.size();ind++){
            mind=max(mind,frek[ind]);
        }
        ans[i]=mind;
    }
    for(int i=0;i<Q;i++){
        cout<<ans[i]<<"\n";
    }
}